import { UUIDValue,BigDecimalValue } from 'gcloud-core-app/src/gcloud/protobuf/basic_pb.js'
import { StringValue } from 'google-protobuf/google/protobuf/wrappers_pb.js'
import { Timestamp } from 'google-protobuf/google/protobuf/timestamp_pb'

UUIDValue.of = function(uuidStr) {
  let value = new UUIDValue();
  value.setValue(uuidStr);
  return value;
};
  
StringValue.of = function(strValue) {
  let value = new StringValue();
  value.setValue(strValue);
  return value;
};

BigDecimalValue.of = function(number) {
  let value = new BigDecimalValue();
  value.setValue(number);
  return value;
};
//给后端传万元
BigDecimalValue.ofWan = function(number) {
  let value = new BigDecimalValue();
  number = number * 10000
  number = number.toString()
  value.setValue(number);
  return value
};
//取出来是元转万元
BigDecimalValue.prototype.getWan = function(number){
  number = number.value
  number = number * 100
  number = number/1000000
  number = number.toString()
  let decimalsL = number.split('.')
  if(decimalsL[1]&&decimalsL[1].length>7){
    number = parseFloat(number)
    number = number.toFixed(6)
    number = number.toString()
  }
  return number
};

Timestamp.of = function(time) {
  let date = new Date(time)
  let value = new Timestamp
  let stamp = date.getTime()
  value.setSeconds(stamp)
  return value;
};

//时间戳转仿真表单日期
Timestamp.prototype.DateFormat = function(format){
  var date = new Date(format);
  var Y = date.getFullYear();
  var M = (date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1);
  var D = date.getDate() < 10 ? '0' + date.getDate() : date.getDate();
  var h = date.getHours() + ':';
  var m = date.getMinutes() + ':';
  var s = date.getSeconds();
  return {Y,M,D}
}
Timestamp.DateFormat = function(format){
	var date = new Date(format);
	var Y = date.getFullYear();
	var M = (date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1);
	var D = date.getDate() < 10 ? '0' + date.getDate() : date.getDate();
	var h = date.getHours() + ':';
	var m = date.getMinutes() + ':';
	var s = date.getSeconds();
	var value = Y+'-'+M+'-'+D
	return value
}
//数字转金额格式
BigDecimalValue.format = function(s){
	if(/[^0-9\.]/.test(s)) return "invalid value";
	s=s.replace(/^(\d*)$/,"$1.");
	s=(s+"00").replace(/(\d*\.\d\d)\d*/,"$1");
	s=s.replace(".",",");
	var re=/(\d)(\d{3},)/;
	while(re.test(s))
			s=s.replace(re,"$1,$2");
	s=s.replace(/,(\d\d)$/,".$1");
	return s.replace(/^\./,"0.")
}

export { UUIDValue,StringValue,Timestamp,BigDecimalValue };